// calcul_exposant_efficace.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define MAX_NB_EXPOSANTS_16BITS 16
int nb_exposants_16bits = 0;
FILE * output=NULL;
unsigned long base=0;
unsigned long exp_i[MAX_NB_EXPOSANTS_16BITS];
unsigned long modulo=0;
//usage
void usage() {
  fprintf(stderr, "Usage: calcul_exposant_efficace -base b -exposant e -modulo m (a exposant b mod c)\n");
  exit(1);
}
int calcul_exposant_efficace(unsigned long base,unsigned long exp_i[],unsigned long modulo,FILE* file, int nb_16bits_exposant)
{
	int d = 1;
	unsigned long bk= 0;
	unsigned long expk = 0;
	for (int p=0; p<nb_16bits_exposant; p++)
	{
		for (int k = 15 ; k>=0 ;k--)
		{
			
			fprintf(output,"k:%i ",k);
			d = (d*d)%modulo;
			expk= 1<<k;
			bk=(exp_i[p]&expk);
			if (bk){
				d = (d*base)%modulo;
				fprintf(output,"bk:%i ",bk); 
			}
			fprintf(file,"d: %i \n",d);
		}
	}
	return (d);
}

int main(int argc, char* argv[])
{
	int i=1;
	int nb_exposants_16bits=0;
	output = fopen("resultats.txt","w");
	while(i < argc) 
	{
		if(strcmp(argv[i],"-b")==0 ) {
		  i++;
		  base= atol(argv[i]);
		  i++;
		}
		else if(strcmp(argv[i],"-e")==0) {
		  do{
				i++;
				exp_i[nb_exposants_16bits]= atol(argv[i]);
				nb_exposants_16bits++;
				i++;
		  }while (strcmp(argv[i],".")==0);
		  
		}else if(strcmp(argv[i],"-m")==0) {
		  i++;
		  modulo= atol(argv[i]);
		  i++;
		}
		else
			i++;
	}
	if (!base&&!exp_i&&modulo){
		usage();
	}

	int reponse = calcul_exposant_efficace(base,exp_i,modulo,output,nb_exposants_16bits);

	int k=0;
	fprintf(stdout,"Calcul_exposant_efficace (Francis Pieraut 11 fevrier 2001) \n\n");
	fprintf(stdout,"%d exposant (",base);
	for (k=0;k<nb_exposants_16bits;k++){
			fprintf(stdout,"%d ",exp_i[k]);	
	}				
	fprintf(stdout,") modulo %d = %d\n",modulo,reponse);

	fprintf(output,"Calcul_exposant_efficace (Francis Pieraut 11 fevrier 2001) \n\n");
	fprintf(output,"%d exposant (",base);
	for ( k=0;k<nb_exposants_16bits;k++){
			fprintf(output,"%d ",exp_i[k]);	
	}				
	fprintf(output,") modulo %d = %d\n",modulo,reponse);

	
	
	fclose(output);
	return 0;
}
